-- Script by Indev made For funny War map of Patafoin

-- Maps where script should be active
local MAPS = {
    MAPGR = 85*TICRATE,
	MAPIZ = 251*TICRATE,
	MAPG9 = 115*TICRATE,
}

-- Extra time awarded to player in singleplayer, local to map
local SINGLEPLAYER_CHECKPOINT_BONUS = {
	MAPGR = 3*TICRATE,
	MAPG9 = 1*TICRATE,
}

-- Extra time that player gets at the beginning (2*GAMESPEED_BONUS for easy speed, GAMESPEED_BONUS for normal speed and no bonus for hard speed)
local GAMESPEED_BONUS = 5*TICRATE

-- Thing and sfx type for checkpoints
freeslot(
	"MT_WARMAP_CHECKPOINT",
	"SFX_WARTIM",
	"SFX_WARTUP",
	"SFX_WARDED",
	"SFX_WARPDE"
)

-- Sound that plays each second when you have less than 10 seconds of timer left
local WARNSOUND = sfx_wartim

-- Sound that plays to player when they run out of time
local KILLSOUND = sfx_warded

-- Same but only played to player who run out of time
local KILLSOUNDLOCAL = sfx_warpde

-- Sound that plays when time was added to player timer
local ADDTIMESOUND = sfx_wartup

-- Time before war elim logic starts
local LEVELSTARTTIME = 7*TICRATE

-- Time before exitlevel, after game finished
local EXITLEVELTIME = 7*TICRATE

local WORSTPLACE = INT32_MAX
local CHECKPOINT_TIMETABLES = {
	{
		num_players = 1,
		
		checkpoint_times = {
			{ place = 1,          time = 10*TICRATE, },
			{ place = WORSTPLACE, time = 10*TICRATE, },
		},
	},
	{
		num_players = 2,
		
		checkpoint_times = {
			{ place = 1,          time = 14*TICRATE, },
			{ place = WORSTPLACE, time = 9*TICRATE, },
		},
	},
	{
		num_players = 4,
		
		checkpoint_times = {
			{ place = 1,          time = 15*TICRATE, },
			{ place = 2,          time = 12*TICRATE, },
			{ place = 3,          time = 10*TICRATE, },
			{ place = WORSTPLACE, time =  8*TICRATE,  },
		},
	},
	{
		num_players = 8,
		
		checkpoint_times = {
			{ place = 1,          time = 15*TICRATE, },
			{ place = 3,          time = 12*TICRATE, },
			{ place = 5,          time = 10*TICRATE, },
			{ place = 7,          time =  8*TICRATE, },
			{ place = WORSTPLACE, time =  6*TICRATE, },
		},
	},
	{
		num_players = 12,
		
		checkpoint_times = {
			{ place = 1,          time = 15*TICRATE, },
			{ place = 2,          time = 14*TICRATE, },
			{ place = 4,          time = 12*TICRATE, },
			{ place = 6,          time = 10*TICRATE, },
			{ place = 8,          time = 9*TICRATE, },
			{ place = 10,         time =  8*TICRATE, },
			{ place = WORSTPLACE, time =  6*TICRATE, },
		},
	},
	{
		num_players = 16,
		
		checkpoint_times = {
			{ place = 1,          time = 16*TICRATE, },
			{ place = 2,          time = 14*TICRATE, },
			{ place = 5,          time = 12*TICRATE, },
			{ place = 9,         time =  10*TICRATE, },
			{ place = 11,         time =  9*TICRATE, },
			{ place = 12,         time =  8*TICRATE, },
			{ place = WORSTPLACE, time =  6*TICRATE, },
		},
	},
}

-- Time player gets for hitting someone
local ORBITIME = 5*TICRATE -- Hit by orbi
local JAWZTIME = 5*TICRATE -- Hit by jawz
local BANANATIME = 3*TICRATE -- Hit by banana
local BANANASNIPETIME = 10*TICRATE -- Hit by banana snipe
local INVTIME = 4*TICRATE -- Hit by invincibility
local SQUISHTIME = 5*TICRATE -- Hit by grow
local MINETIME = 2*TICRATE -- Spun out by mine
local MINEEXPLODETIME = 6*TICRATE -- Exploded by mine
local EGGMANTIME = 3*TICRATE -- Exploded by eggman monitor
local BALLHOGTIME = 3*TICRATE -- Hit by ballhog
local SPBTIME = 5*TICRATE/2 -- Spun out by spb
local SPBEXPLODETIME = 3*TICRATE -- Exploded by spb
local THUNDERSHIELDTIME = 3*TICRATE -- Hit by thunder shield
local SINKTIME = 20*TICRATE -- Hit by kitchen sink


-- Name for LinedefExecute
local CHECKPOINT_LINEDEF = "WARCHECK"

local war_elim = false
local war_elim_startclocktimer = 0
local war_elim_started = false
local war_elim_starttime = 0
local war_elim_exitlevel = false
local war_elim_exitlevel_timer = 0
local war_elim_singleplayer = false

local function countActivePlayers()
    local count = 0

    for player in players.iterate do
        if not player.spectator and not player.deathtime then
            count = count + 1
        end
    end

    return count
end

local function getCheckpointTimeTable()
	local alive = countActivePlayers()
	
	local i = 1
	
	while CHECKPOINT_TIMETABLES[i].num_players < alive do
		i = i + 1
		
		if i > #CHECKPOINT_TIMETABLES then
			print("\130WARNING:\128 could not pick correct time table, using last one anyway")
			i = i - 1
			break
		end
	end
	
	return CHECKPOINT_TIMETABLES[i].checkpoint_times
end

local function getCheckpointTime(position)
	local timetable = getCheckpointTimeTable()
	
	local i = 1
	
	while timetable[i].place < position do
		i = i + 1
		
		if i > #timetable then
			print("\130WARNING:\128 could not pick correct award time from time table, using last one anyway")
			i = i - 1
			break
		end
	end

    local bonus = 0

    if war_elim_singleplayer then
        bonus = SINGLEPLAYER_CHECKPOINT_BONUS[G_BuildMapName(gamemap)] or 0
    end
	
	return timetable[i].time + bonus
end

-- Fatality
local function kill(player)
	S_StartSound(nil, KILLSOUND)
    S_StartSound(nil, KILLSOUNDLOCAL, player)
	print("\133"..player.name.." got eliminated...")

    player.kartstuff[k_position] = countActivePlayers()

    player.deathtime = leveltime
    player.lives = 0
    player.pflags = player.pflags | PF_TIMEOVER

    P_DamageMobj(player.mo, nil, nil, 10000)

    if player.mo and player.mo.valid then
        player.mo.momx = 0
        player.mo.momy = 0
        player.mo.momz = 0
    end
end

-- Executed per each player in game
local function tickClock(player)
    -- Animation of time going up after player got extra time
    if player.addtimeanim then
        player.addtimeanim = max(0, player.addtimeanim - 17)
    end

    if not player.exiting then
        player.clock = player.clock - 1

        -- You ran out of time! Time to die >:)
        if player.clock <= 0 then
            kill(player)
        elseif player.clock <= 15*TICRATE and player.clock % TICRATE == 0 then
            S_StartSound(player.mo, WARNSOUND)
        end
    end
end

local function addClockTime(player, time)
	local mins = G_TicsToMinutes(time)
    local secs = G_TicsToSeconds(time)
	local centis = G_TicsToCentiseconds(time)
	
	local timestr = mins < 10 and "0" or ""
	timestr = timestr..mins
	
	timestr = timestr..":"
	
	timestr = timestr..(secs < 10 and "0" or "")
	timestr = timestr..secs
	
	timestr = timestr..":"
	
	timestr = timestr..(centis < 10 and "0" or "")
	timestr = timestr..centis

	CONS_Printf(player, "\131Time extended! +"..timestr)

    player.clock = player.clock + time
    player.addtimeanim = player.addtimeanim + time

    if not S_IdPlaying(ADDTIMESOUND, player) then
        S_StartSound(nil, ADDTIMESOUND, player)
    end
end


local function getMapID(n)
    if n < 100 then
        return ((n < 10) and ("0"..n) or tostring(n))
    end

    local x = n - 100
    local p = x / 36
    local q = x - (36 * p)
    local a = string.char(string.byte('A') + p)
    local b = (q < 10) and tostring(q) or string.char(string.byte('A') + q - 10)

    return a..b
end

local function assignWarElimScores()
    local places = {}

    for player in players.iterate do
        if not player.spectator then
            if player.deathtime == nil then
                player.realtime = 60*TICRATE
            else
                player.exiting = 1
                player.pflags = player.pflags & ~PF_TIMEOVER
                player.lives = 1

                table.insert(places, player)
            end
        end
    end

    table.sort(places, function(p1, p2) return p1.deathtime > p2.deathtime end)

    local timemul = 1
    local prevdeathtime = 0
    for _, player in ipairs(places) do
        if player.deathtime ~= prevdeathtime then timemul = timemul + 1 end
        prevdeathtime = player.deathtime

        player.realtime = timemul*60*TICRATE
    end
end

local function doWarCheckpoint(player)
    -- Award player with bonus time
    addClockTime(player, getCheckpointTime(player.kartstuff[k_position]))
end

local function resetWarElim()
    for player in players.iterate do
        player.clock = nil
        player.addtimeanim = 0
        player.deathtime = nil
    end

    war_elim_started = false
end

addHook("NetVars", function(net)
    war_elim = net(war_elim)
    war_elim_started = net(war_elim_started)
	war_elim_startclocktimer = net(war_elim_startclocktimer)
    war_elim_starttime = net(war_elim_starttime)
    war_elim_exitlevel = net(war_elim_exitlevel)
    war_elim_exitlevel_timer = net(war_elim_exitlevel_timer)
	war_elim_singleplayer = net(war_elim_singleplayer)
end)

addHook("MapLoad", function(mapid)
    local mapname = "MAP"..getMapID(mapid)

    war_elim_startclocktimer = MAPS[mapname]
	war_elim = war_elim_startclocktimer ~= nil

    if war_elim then
        resetWarElim()
    else
        hud.enable("gametypeinfo")
    end
end)

addHook("LinedefExecute", function(line, pmo, sector)
    if not war_elim and not war_elim_started or war_elim_exitlevel then return end
    if not pmo.player then return end

    local player = pmo.player
    local checkpoint

    for mo in sector.thinglist() do
        if mo.type == MT_WARMAP_CHECKPOINT and mo.spawnpoint then
            checkpoint = mo.spawnpoint
			break
        end
    end

    if not checkpoint then
        print("\130WARNING:\128 checkpoint sector without checkpoint thing")
        return
    end

    if player.war_elim_checkpoint == nil then
        player.war_elim_checkpoint = 0
    end

    if player.war_elim_checkpoint <= checkpoint.angle then
        player.war_elim_checkpoint = checkpoint.angle + 1
        doWarCheckpoint(player)
    end
end, CHECKPOINT_LINEDEF)

addHook("PlayerSpin", function(victim, inflictor, pmo)
	if not war_elim or not war_elim_started or war_elim_exitlevel then return end
    if not pmo or not pmo.player or pmo.player.spectator or pmo.player.deathtime then return end

    local player = pmo.player

    if player == victim then return end

    local SPIN_TIMES = {
        [MT_BANANA] = BANANATIME,
        [MT_BANANA_SHIELD] = BANANATIME,
        [MT_ORBINAUT] = ORBITIME,
        [MT_ORBINAUT_SHIELD] = ORBITIME,
        [MT_JAWZ] = JAWZTIME,
        [MT_JAWZ_DUD] = JAWZTIME,
        [MT_JAWZ_SHIELD] = JAWZTIME,
        [MT_BALLHOG] = BALLHOGTIME,
        [MT_SPB] = SPBTIME,
        [MT_SPBEXPLOSION] = SPBTIME,
        [MT_MINEEXPLOSION] = MINETIME,
        [MT_SSMINE] = MINETIME,
        [MT_SSMINE_SHIELD] = MINETIME,
    }

    local award_time

    if inflictor.type == MT_BANANA and inflictor.health > 1 then
        award_time = BANANASNIPETIME
    elseif inflictor.type == MT_SPBEXPLOSION and not inflictor.extavalue1 then
        award_time = EGGMANTIME
    elseif SPIN_TIMES[inflictor.type] then
        award_time = SPIN_TIMES[inflictor.type]
    else
        if inflictor.player then
            if inflictor.player.kartstuff[k_invincibilitytimer] then
                award_time = INVTIME
            elseif inflictor.player.kartstuff[k_curshield] == 1 then
                award_time = THUNDERSHIELDTIME
            end
        end
    end

    if award_time then addClockTime(player, award_time) end
end)

addHook("PlayerExplode", function(victim, inflictor, pmo)
	if not war_elim or not war_elim_started or war_elim_exitlevel then return end
    if not pmo or not pmo.player or pmo.player.spectator or pmo.player.deathtime then return end

    local player = pmo.player

    if player == victim then return end

    local EXPLODE_TIMES = {
        [MT_SPBEXPLOSION] = SPBEXPLODETIME,
        [MT_MINEEXPLOSION] = MINEEXPLODETIME,
        [MT_SSMINE] = MINEEXPLODETIME,
        [MT_SSMINE_SHIELD] = MINEEXPLODETIME,
    }

    local award_time

    if inflictor.type == MT_SPBEXPLOSION and not inflictor.extravalue1 then
        award_time = EGGMANTIME
    else
        award_time = EXPLODE_TIMES[inflictor.type]
    end

    if award_time then addClockTime(player, award_time) end
end)

addHook("PlayerSquish", function(victim, inflictor, pmo)
	if not war_elim or not war_elim_started or war_elim_exitlevel then return end
    if not pmo or not pmo.player or pmo.player.spectator or pmo.player.deathtime then return end

    local player = pmo.player

    if player == victim then return end

    addClockTime(player, SQUISHTIME)
end)

addHook("MobjDamage", function(victim_mo, inflictor, pmo)
	if not war_elim or not war_elim_started or war_elim_exitlevel then return end
    local victim = victim_mo.player

    if not pmo or not pmo.player or pmo.player.spectator or pmo.player.deathtime then return end

    local player = pmo.player

    if player == victim then return end

    if inflictor and inflictor.type == MT_SINK then
        addClockTime(player, SINKTIME)
    end
end, MT_PLAYER)

addHook("ThinkFrame", function()
    if not war_elim then return end
    if leveltime < LEVELSTARTTIME then return end

    if not war_elim_started then
        war_elim_starttime = leveltime
        war_elim_started = true
        war_elim_exitlevel = false
        war_elim_exitlevel_timer = EXITLEVELTIME
		war_elim_singleplayer = countActivePlayers() == 1
    end

    if war_elim_started and not war_elim_exitlevel then
        for player in players.iterate do
            if not player.spectator and not player.deathtime then
                if player.war_elim_lap == nil then
                    player.war_elim_lap = player.laps
                elseif player.war_elim_lap ~= player.laps then
                    player.war_elim_lap = player.laps
                    player.war_elim_checkpoint = 0
                end

                if player.clock == nil then
                    -- Do that so mid joiners don't have adventage
                    player.clock = war_elim_startclocktimer - leveltime + war_elim_starttime + (2 - gamespeed) * GAMESPEED_BONUS
                end

                tickClock(player)
            end
        end

        local alive = countActivePlayers()
		
		-- Someone entered the game
		if alive > 1 and war_elim_singleplayer then
			war_elim_singleplayer = false
		end

        if alive == 0 then
            -- S_ChangeMusic("KRFAIL")
			
			if not war_elim_singleplayer then
				chatprint("\133*Everyone got eliminated...")
            end

			war_elim_exitlevel = true
        elseif alive == 1 and not war_elim_singleplayer then
            local winner

            for player in players.iterate do
                if not player.spectator and player.deathtime == nil then
                    winner = player
                end
            end

            -- Just in case winner spectated immideatly after win (which is stupid, but possible, i think)
            if winner then
				winner.kartstuff[k_position] = 1
                winner.exiting = 1
				S_StartSound(winner.mo, sfx_kwin)
                S_ChangeMusic("KRWIN", false)
                chatprint("\131*"..winner.name.." survived!")
            end

            war_elim_exitlevel = true
        end
    end

    if war_elim_exitlevel then
        war_elim_exitlevel_timer = war_elim_exitlevel_timer - 1

        if war_elim_exitlevel_timer == 0 then
			assignWarElimScores()
            G_ExitLevel()
        end
    end
end)

addHook("MusicChange", function(old, new, mflags, looping, position, prefadems, fadems)
	new = new:upper()
	old = old:upper()
	
	if war_elim and (new == "KGROW" or new == "KINVNC") then
		return old, mflags, looping, position, prefadems, fadems
	end
end)

local cache

-- Draw two-character wide num
local function drawNum2(v, x, y, scale, num, patches, flags)
    v.drawScaled(x, y, scale, patches[num/10+1], flags)
    v.drawScaled(x+FixedMul(scale, 40*FRACUNIT), y, scale, patches[num%10+1], flags)
end

-- Draw time on timer
local function drawTime(v, x, y, scale, secs, mins, patches, flags)
    drawNum2(v, x, y, scale, mins, patches, flags)
    drawNum2(v, x + FixedMul(scale, 100*FRACUNIT), y, scale, secs, patches, flags)
end

-- Draw the clock
local function drawClock(v, x, y, scale, mins, secs, red, flags)
    if red then
        v.drawScaled(x, y, scale, cache.timer_red, flags)

        drawTime(v, x + FixedMul(100*FRACUNIT, scale), y + FixedMul(50*FRACUNIT, scale), scale, secs, mins, cache.num_red, flags)
    else
        v.drawScaled(x, y, scale, cache.timer_green, flags)

        drawTime(v, x + FixedMul(100*FRACUNIT, scale), y + FixedMul(50*FRACUNIT, scale), scale, secs, mins, cache.num_green, flags)
    end
end

local TIMER_SCALE = FRACUNIT/6

hud.add(function(v, player)
    if not cache then
        cache = {}

        cache.timer_red = v.cachePatch("K_TIMERR")
        cache.timer_green = v.cachePatch("K_TIMERG")

        cache.num_red = {v.cachePatch("K_PTRED0")}
        for i = 1, 9 do table.insert(cache.num_red, v.cachePatch("K_PTRED"..i)) end

        cache.num_green = {v.cachePatch("K_PTGRE0")}
        for i = 1, 9 do table.insert(cache.num_green, v.cachePatch("K_PTGRE"..i)) end
    end

    if not war_elim or player.clock == nil then return end

    hud.disable("gametypeinfo")

    local splitnum = nil
    for i = 0, splitscreen do
        if displayplayers[i] == player then
            splitnum = i
        end
    end

    local displaytime = max(0, player.clock - (player.addtimeanim or 0))

	-- Adjust display time to one second so when less than one second left it
	-- displays 00:01 and only when its 0 it displays 00:00
	-- Kinda stupid, but it works
	displaytime = displaytime + (displaytime ~= 0 and TICRATE or 0)

    local mins = G_TicsToMinutes(displaytime, true)
    local secs = G_TicsToSeconds(displaytime)

    local x, y
    local flags = 0

    if splitscreen then
        if splitscreen == 1 then
            x = 10*FRACUNIT
            y = (splitnum == 0 and 100*FRACUNIT or 200*FRACUNIT) - FixedMul(111*FRACUNIT, TIMER_SCALE)

            flags = (splitnum == 1 and V_SNAPTOBOTTOM|V_SNAPTOLEFT) or V_SNAPTOLEFT
        else
            x = (splitnum == 0 or splitnum == 2) and 10*FRACUNIT or 170*FRACUNIT
            y = ((splitnum == 0 or splitnum == 1) and 100*FRACUNIT or 200*FRACUNIT) - FixedMul(111*FRACUNIT, TIMER_SCALE)

            if splitnum == 0 or splitnum == 2 then flags = flags | V_SNAPTOLEFT end
            if splitnum == 2 or splitnum == 3 then flags = flags | V_SNAPTOBOTTOM end
        end

    else
        x = 10*FRACUNIT
        y = 200*FRACUNIT - FixedMul(111*FRACUNIT, TIMER_SCALE)

        flags = V_SNAPTOBOTTOM|V_SNAPTOLEFT
    end

    drawClock(v, x, y, TIMER_SCALE, mins, secs, not player.addtimeanim, flags)
end)

-- Debug
--[[COM_AddCommand("addtime", function(p, name, amount)
    for player in players.iterate do
        if player.name == name then
            addClockTime(player, tonumber(amount) or 0)
			return
        end
    end
	
	CONS_Printf(p, "Player '"..(name or "").."' not found")
end, COM_ADMIN)
--]]
